<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Products config</title>
</head>
<body>
    
    <h1>Products config structure</h1>

    <p>Product config should be named as {name}.products.js where {name} is customizer or website name e.g. variant, calamigos, xilliam, etc...</p>
    <p>{name}.products.js config should contain constant PRODUCTS{} with products information, later on mentioned as items</p>
    <p>Item config structure:</p>
    <pre>
        model: {
            name: 'calamigos-sweater', // (string) - defines which class to load in ModelPicker.ts
        },
        parts: [ // holds information about textures, stitches, colors and text
            {
                name: 'Front', // visual name of this part (for packing slip)
                key: 'front', // unique KEY (string, lowercase, no spaces)
                group: 'body-front', // used in multiple fields - for custom text, base color, etc, should also be unique in parts
                layers: [
                    // ONCE LOAD ALL THE STITCHES, check <a href="#DEFAULT_STITCHES">DEFAULT_STITCHES</a> at the bottom
                    {
                        type: 'texture', // texture type layer, requires value with texture/mask/image name && unique key
                        value: 'texture_image_or_mask.png',
                        key: 'front-texture', // should start with part's key (in this key its 'front') then separated by - (minus sign) and add whatever word defines this key best, e.g. 'texture'
                    },
                    {
                        type: 'stitch', // stitch type layer (similar to texture), requires value with texture/mask/image name && unique key
                        value: 'stitch_image.png',
                        key: 'front-stitch', // same as above for type='texture' key.
                    },
                    { 
                        type: 'text', // type text - custom text layer
                        key: 'front-letter', // should match key in UI with type='input'
                        group: 'letter',  // required for color changes, this group should exist in UI config down the page
                    },
                    {
                        type: 'color', // color type defines which color is default (at start) for specific layer on texture
                        key: 'front-base', // key - follow rules from layers -> type = 'texture'
                        value: '35469d', // clean color code (no # or 0x at the start),
                        group: 'base-color', // defines UI group which triggers color change
                    },
                    {
                        type: 'color',
                        key: 'ornament-color',
                        value: '000000',
                        group: 'ornaments'
                    }
                ]
            },
            // ... more parts
        ],
        ui : [
            {
                type: 'color', // color type. If ui group doesnt have type it will be 'color' by default.
                name: 'Base Color', // visible UI group name
                key: 'base-colors', // UI key
                group: ['base-color'], // when matched with group name (string) from layers, changes parameters on those layers
                value: [ // list of color codes for this group
                    000000,
                    ffffff,
                    00ff00,
                    ff00ff,
                ],
                rules: {
                    unique: true, // when unique == true prevents other UI groups from having color of this group
                },
                pins: { // if you need pins/zoom mechanics
                    position: [-2, 2, 5], // position of pin (Press P on localhost to easily adjust pin position)
                    view: [-18, 55, 286],  // camera position for pin viewing
                    invisible: true, // if true, then pin will not be visible on screen, but camera will move (zoom in/out) while looking at 'position'
                }
            }, 
            {
                type: 'input', // input type - for input fields on custom text
                name: 'Front Letters',
                key: 'front-letter', // when type == 'input', key must match layer key (at this key front-letter)
                group: ['body-front'], // on which part this letter should be drawn. Requires group of that part.
                value: 'X', // default text value
                rules: {
                    limit: 1, // limit characters
                    color: '00ff00', // default custom text color
                    stitch: 'FF0000', // default stitch used
                    required: true,  // if custom text is required and cannot be left blank
                    position: { // custom text position
                        x: 65,
                        y: 30,
                    },
                    font: 'bold 200px Arial', // font style for custom text
                    uppercase: true, // if user inputed text should be transformed to uppercase letters
                },
            },
        ]
    </pre>

    <h2 id="DEFAULT_STITCHES">DEFAULT_STITCHES</h2>
    <pre>
    const DEFAULT_STITCHES = [// best case scenario - each product should have their own stitches defined, but for now they can be here and included into each product
    
            {   
                type: 'stitch_normal',
                value: 'JCQ_normal.png',
                key: 'JCQ_normal',
            },
            {
                type: 'stitch_normal',
                value: 'WDE_normal.png',
                key: 'WDE_normal',
            },
            {
                type: 'stitch_normal',
                value: 'CLR_normal.png',
                key: 'CLR_normal',
            },
            {
                type: 'stitch_mask',
                value: 'JCQ_mask.png',
                key: 'JCQ_mask'
            },
            {
                type: 'stitch_mask',
                value: 'WDE_mask.png',
                key: 'WDE_mask'
            },
            {
                type: 'stitch_mask',
                value: 'CLR_mask.png',
                key: 'CLR_mask'
            },
            {
                type: 'stitch_text',
                value: 'stitch_jacquard.png',
                key: 'JCQ_text',
            },
            {
                type: 'stitch_text',
                value: 'stitch_wide.png',
                key: 'WDE_text',
            },
            {
                type: 'stitch_text',
                value: 'stitch_tuck.png',
                key: 'TCK_text',
            }
        ]
    </pre>

</body>
</html>